/*

Test for CryptoAPI 

Author : CARDON de Lichtbuer Rodolphe
Augustus 2006
rodolphe@wol.be

*/


#pragma comment (lib, "crypt32.lib")
#pragma comment (lib, "cryptui.lib")
#pragma comment (lib, "advapi32.lib")
#pragma comment (lib, "kernel32.lib")
#pragma comment (lib, "Cryptnet.lib")

#include <stdio.h>
#include <io.h>
#include "windows.h"
#include "wincrypt.h"

int main(int argcount, char* arg){

HCERTSTORE store;
const void* pvPara = (const void*) L"My";

//opencertstore 'My'
store=CertOpenStore(
  CERT_STORE_PROV_SYSTEM,
  0,
  NULL,
  CERT_SYSTEM_STORE_CURRENT_USER,
  pvPara
 );

//displays all the certificates to standard output
//for each certificate displays caracteristics : object...
//for each certificate displays 'extended properties' 

PCCERT_CONTEXT  certificateContext=NULL;
//char* name = (char*) malloc(100); 
LPWSTR name = (LPWSTR) malloc(100); 
char buffer_prop[500];
DWORD sizename;
DWORD sizebuf;


while(certificateContext=CertEnumCertificatesInStore(store, certificateContext))
	{
	sizename = (DWORD)100; 
	sizename = CertGetNameStringW(
				  certificateContext,
				  CERT_NAME_FRIENDLY_DISPLAY_TYPE,
				  0,
				  0,
				  name,
				  sizename);
	wprintf(L"\nNom du certificat : %s\n",name);
	printf("Taille du certificat : %d\n", certificateContext->cbCertEncoded);
	sizebuf = (DWORD)500;
	if(CertGetCertificateContextProperty(certificateContext,
										CERT_KEY_PROV_INFO_PROP_ID,
										buffer_prop,
										&sizebuf))
		{
		CRYPT_KEY_PROV_INFO *info = (CRYPT_KEY_PROV_INFO*) buffer_prop;
		
		wprintf(L"Container name = \n  %s\n",info->pwszContainerName);
		wprintf(L"Provider name = \n  %s\n",info->pwszProvName);
		wprintf(L"Provider type number = \n  %d\n",info->dwProvType);
		wprintf(L"Key spec type number = \n  %d\n",info->dwKeySpec);
		
		
	    }else{
		//nok
		wprintf(L"Erreur en lisant la proprit CERT_KEY_PROV_INFO_PROP_ID\n");

		if(CRYPT_E_NOT_FOUND==GetLastError()){
			printf(" Erreur = %s\n","CRYPT_E_NOT_FOUND");
		}else if(ERROR_MORE_DATA==GetLastError()){
				printf("erreur = %s\n","ERROR_MORE_DATA");
		}else{
				printf("erreur = %s\n","UNKNOWN");
		}
	}
}


// Message to sign
char* message = "abc"; //ASCII
int messagelen = 3; // 3 bytes without NULL
//bool* messdump = (int*)message;
printf("dump first lettre (decimal) = %d",*message);


// select the first cert
printf("select the first cert:\n");
PCCERT_CONTEXT mycert=CertEnumCertificatesInStore(store, NULL);
mycert=CertEnumCertificatesInStore(store, mycert);



sizename = (DWORD)100; 
sizename = CertGetNameStringW(mycert,  CERT_NAME_FRIENDLY_DISPLAY_TYPE,
				  0,  0,   name,  sizename);
wprintf(L"name = %s\n",name);

sizebuf = (DWORD)500;
CRYPT_KEY_PROV_INFO *info; 
if(CertGetCertificateContextProperty(mycert,CERT_KEY_PROV_INFO_PROP_ID,
										buffer_prop,
										&sizebuf))
		{
		info = (CRYPT_KEY_PROV_INFO*) buffer_prop;
		
		wprintf(L"Container name = \n  %s\n",info->pwszContainerName);
		wprintf(L"Provider name = \n  %s\n",info->pwszProvName);
		wprintf(L"Provider type number = \n  %d\n",info->dwProvType);
		wprintf(L"Key spec type number = \n  %d\n",info->dwKeySpec);
	}

HCRYPTPROV hCryptProv;
HCRYPTPROV* phCryptProv=&hCryptProv;
DWORD dwKeySpec=NULL;
BOOL fCallerFreeProv;
printf("with cryptacquirecertificate...\n");
if(!CryptAcquireCertificatePrivateKey(mycert,CRYPT_ACQUIRE_CACHE_FLAG,NULL,phCryptProv,
	&dwKeySpec,&fCallerFreeProv)){
	printf("error with cryptacquirecertificate...");
	exit(1);
}

HCRYPTHASH hHash;
HCRYPTHASH* phHash = &hHash;
printf("with createhash...\n");
if(!CryptCreateHash(*phCryptProv,CALG_SHA1,0,0,phHash)){
	printf("error with creating hash\n");
	printf("\nerror num %d\n",GetLastError());
	exit(1);
}
printf("with CryptHashData...\n");
if(!CryptHashData(*phHash, (const BYTE*) message, messagelen, 0)){
	printf("error with hashData");
	printf("\nerror num %d\n",GetLastError());
	exit(1);
}

/*
if(!CryptSetProvParam(hCryptProv,
  HCRYPTPROV hProv,
  DWORD dwParam,
  BYTE* pbData,
  DWORD dwFlags
)){
	printf("error with setparam");
	printf("\nerror num %d\n",GetLastError());
	exit(1);
}
*/

char signature[1000];
DWORD SignatureLength = 1000;
DWORD* pSignatureLength = &SignatureLength;

printf("with CryptSignHash...\n");
if(!CryptSignHash(*phHash,dwKeySpec,NULL,0,(BYTE*)signature, pSignatureLength)){
	printf("error while signing hash");
	printf("\nerror num %d\n",GetLastError());
	printf("\nERROR_MORE_DATA = %d",ERROR_MORE_DATA);
	printf("\nERROR_INVALID_HANDLE = %d",ERROR_INVALID_HANDLE);
	printf("\nERROR_INVALID_PARAMETER = %d",ERROR_INVALID_PARAMETER);
	printf("\nNTE_NO_MEMORY = %d",NTE_NO_MEMORY);
	printf("\nNTE_BAD_ALGID = %d",NTE_BAD_ALGID);
	printf("\nNTE_BAD_FLAGS = %d",NTE_BAD_FLAGS);
	printf("\nNTE_BAD_UID = %d",NTE_BAD_UID);
	printf("\nNTE_BAD_HASH = %d",NTE_BAD_HASH);
	printf("\nNTE_NO_KEY = %d",NTE_NO_KEY);
	printf("\nNTE_BAD_KEYSET = %d",NTE_BAD_KEYSET);

/*The key container could not be opened. A common cause of this error is
that the key container does not exist. To create a key container, call 
CryptAcquireContext using the CRYPT_NEWKEYSET flag. This error code can
also indicate that access to an existing key container is denied. Access 
rights to the container can be granted by the key set creator by using 
CryptSetProvParam.*/

	exit(1);
}

printf("signature length = %d",SignatureLength);
unsigned char* aschar = (unsigned char*)signature;
printf("signature first val (decimal)= %d\n",*aschar);
printf("signature second val (decimal)= %d\n",*(aschar+1));
printf("signature second val (decimal)= %d\n",*(aschar+2));
printf("signature second val (decimal)= %d\n",*(aschar+3));
printf("signature second val (decimal)= %d\n",*(aschar+4));
printf("signature second val (decimal)= %d\n",*(aschar+5));
printf("signature second val (decimal)= %d\n",*(aschar+6));
printf("signature second val (decimal)= %d\n",*(aschar+7));
printf("signature second val (decimal)= %d\n",*(aschar+8));

char* signOK = (char*)malloc(*pSignatureLength);
 void reversecopy(byte *dest, byte *src, int n);

reversecopy((byte*)signOK, (byte*)signature, *pSignatureLength);

void xdump(BYTE *p, DWORD n);

xdump((BYTE*)signOK,*pSignatureLength);

if(fCallerFreeProv){
if(!CryptReleaseContext(*phCryptProv,NULL))
	{
	printf("error with releasecontext");
	printf("\nerror num %d\n",GetLastError());
	}
else{
	printf("no releasecontext needed");
}
}
//   Clean up.
if (!CertCloseStore(store,0)) {
    printf("Failed CertCloseStore\n");
		printf("\nerror num %d\n",GetLastError());
    exit(1);
   }



printf("\n***\nend\n***\n");
return 0;


}

// hex-dump a block of bytes
// used for debugging
void xdump(BYTE *p, DWORD n)
{
	int i;
	char s[20];
	char c;

	memset(s, 0, 20);
	printf("  0000 ");
	for (i=0; i<(int)n; i++) {
		printf (" %02x", *(p+i));
		c = *(p+i);
		if (isascii(c) && !iscntrl(c))
			s[strlen(s)] = c;
		  else
			  s[strlen(s)] = '.';
		if ( (i&0x0f) == 15) {
			printf("  %s\n  %04x ", s, i+1);
			memset(s, 0, 20);
		}
	}
	printf("  %s\n  %04x ", s, i+1);
	printf("\n");
}

 void reversecopy(byte *dest, byte *src, int n)
{
	int i;
	for (i=0; i<n; i++)
		*(dest+i) = *(src+n-i-1);
}
