/*
Copyright (c) 2006, CARDON DE LICHTBUER Rodolphe
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list 
of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, this 
list of conditions and the following disclaimer in the documentation and/or 
other materials provided with the distribution. 

3. The name of the author or contributors may not be used to endorse or promote 
products derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */

package test;

import be.cardon.cryptoapi.*;
import be.cardon.cryptoapi.provider.*;
import be.cardon.nativecall.cryptoapi.*;
import java.util.*;
import java.io.*;
import java.security.*;
import java.security.cert.*;



/**
 *
 * @author Rodolphe
 */
public class ProviderTest {
    
    /** Creates a new instance of ProviderTest */
    public ProviderTest() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        try{
        CryptoAPIKeyStore store = new CryptoAPIKeyStore();
        byte[] byteName = new String("My").getBytes("UTF-8");
        InputStream in = new ByteArrayInputStream(byteName);
        store.engineLoad(in, null); //my store
        int size = store.engineSize();
        System.out.println("engine size = " + size);
        for(Enumeration<String> aliases = store.engineAliases();aliases.hasMoreElements();){
            String alias = aliases.nextElement();
            System.out.println("=======================================");
            System.out.println("alias : "+alias);
            System.out.println("certificate : " + ((X509Certificate)store.engineGetCertificate(alias)).getIssuerX500Principal().toString());
            System.out.println("certificate : " + ((X509Certificate)store.engineGetCertificate(alias)).getPublicKey().getAlgorithm());
            //Key mykey = store.engineGetKey(alias, null);
            //System.out.println("key alg: " + mykey.getAlgorithm());
        }
        
        
        
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
}
